diff --git a/testing/mozbase/moztest/moztest/results.py b/testing/mozbase/moztest/moztest/results.py
index 435665c670..495cea578e 100644
--- a/testing/mozbase/moztest/moztest/results.py
+++ b/testing/mozbase/moztest/moztest/results.py
@@ -8,7 +8,7 @@ import os
 import mozinfo
 
 
-class TestContext(object):
+class TestContext:
     """ Stores context data about the test """
 
     attrs = ['hostname', 'arch', 'env', 'os', 'os_version', 'tree', 'revision',
@@ -31,7 +31,7 @@ class TestContext(object):
         self.buildtype = buildtype
 
     def __str__(self):
-        return '%s (%s, %s)' % (self.hostname, self.os, self.arch)
+        return '{} ({}, {})'.format(self.hostname, self.os, self.arch)
 
     def __repr__(self):
         return '<%s>' % self.__str__()
@@ -46,12 +46,12 @@ class TestContext(object):
         def get(attr):
             value = getattr(self, attr)
             if isinstance(value, dict):
-                value = frozenset(value.items())
+                value = frozenset(list(value.items()))
             return value
         return hash(frozenset([get(a) for a in self.attrs]))
 
 
-class TestResult(object):
+class TestResult:
     """ Stores test result data """
 
     FAIL_RESULTS = [
@@ -84,7 +84,7 @@ class TestResult(object):
 
         msg = "Result '%s' not in possible results: %s" %\
               (result_expected, ', '.join(self.POSSIBLE_RESULTS))
-        assert isinstance(name, basestring), "name has to be a string"
+        assert isinstance(name, str), "name has to be a string"
         assert result_expected in self.POSSIBLE_RESULTS, msg
 
         self.name = name
@@ -102,12 +102,12 @@ class TestResult(object):
 
     @property
     def test_name(self):
-        return '%s.py %s.%s' % (self.test_class.split('.')[0],
+        return '{}.py {}.{}'.format(self.test_class.split('.')[0],
                                 self.test_class,
                                 self.name)
 
     def __str__(self):
-        return '%s | %s (%s) | %s' % (self.result or 'PENDING',
+        return '{} | {} ({}) | {}'.format(self.result or 'PENDING',
                                       self.name, self.test_class, self.reason)
 
     def __repr__(self):
@@ -170,7 +170,7 @@ class TestResult(object):
             raise ValueError(msg)
 
         # use lists instead of multiline strings
-        if isinstance(output, basestring):
+        if isinstance(output, str):
             output = output.splitlines()
 
         self.time_end = time_end if time_end is not None else time.time()
@@ -206,7 +206,7 @@ class TestResultCollection(list):
             self.resultClass = resultClass
 
     def __str__(self):
-        return "%s (%.2fs)\n%s" % (self.suite_name, self.time_taken,
+        return "{} ({:.2f}s)\n{}".format(self.suite_name, self.time_taken,
                                    list.__str__(self))
 
     def subset(self, predicate):
diff --git a/testing/mozbase/mozversion/mozversion/mozversion.py b/testing/mozbase/mozversion/mozversion/mozversion.py
index 5dfcd306a9..598eb1b2f2 100644
--- a/testing/mozbase/mozversion/mozversion/mozversion.py
+++ b/testing/mozbase/mozversion/mozversion/mozversion.py
@@ -3,7 +3,7 @@
 # You can obtain one at http://mozilla.org/MPL/2.0/.
 
 import argparse
-import ConfigParser
+import six.moves.configparser
 from StringIO import StringIO
 import os
 import re
@@ -15,13 +15,13 @@ import zipfile
 import mozfile
 import mozlog
 
-import errors
+from . import errors
 
 
 INI_DATA_MAPPING = (('application', 'App'), ('platform', 'Build'))
 
 
-class Version(object):
+class Version:
 
     def __init__(self):
         self._info = {}
@@ -38,7 +38,7 @@ class Version(object):
                 self._logger.warning('Unable to find %s' % config_file)
 
     def _parse_ini_file(self, fp, type, section):
-        config = ConfigParser.RawConfigParser()
+        config = six.moves.configparser.RawConfigParser()
         config.readfp(fp)
         name_map = {'codename': 'display_name',
                     'milestone': 'version',
@@ -46,7 +46,7 @@ class Version(object):
                     'sourcestamp': 'changeset'}
         for key, value in config.items(section):
             name = name_map.get(key, key).lower()
-            self._info['%s_%s' % (type, name)] = config.has_option(
+            self._info['{}_{}'.format(type, name)] = config.has_option(
                 section, key) and config.get(section, key) or None
 
         if not self._info.get('application_display_name'):
@@ -86,7 +86,7 @@ class LocalVersion(Version):
             # .exe extension
             if not os.path.exists(binary) and not os.path.exists(binary +
                                                                  '.exe'):
-                raise IOError('Binary path does not exist: %s' % binary)
+                raise OSError('Binary path does not exist: %s' % binary)
             path = os.path.dirname(os.path.realpath(binary))
         else:
             path = os.getcwd()
@@ -146,7 +146,7 @@ class B2GVersion(Version):
             with open(gaia_commit) as f:
                 changeset, date = f.read().splitlines()
                 self._info['gaia_changeset'] = re.match(
-                    '^\w{40}$', changeset) and changeset or None
+                    r'^\w{40}$', changeset) and changeset or None
                 self._info['gaia_date'] = date
         except KeyError:
             self._logger.warning(
@@ -163,7 +163,7 @@ class LocalB2GVersion(B2GVersion):
 
         if binary:
             if not os.path.exists(binary):
-                raise IOError('Binary path does not exist: %s' % binary)
+                raise OSError('Binary path does not exist: %s' % binary)
             path = os.path.dirname(binary)
         else:
             if os.path.exists(os.path.join(os.getcwd(), 'application.ini')):
@@ -241,8 +241,8 @@ class RemoteB2GVersion(B2GVersion):
             'ro.product.device': 'device_id'}
         for line in build_props.split('\n'):
             if not line.strip().startswith('#') and '=' in line:
-                key, value = [s.strip() for s in line.split('=', 1)]
-                if key in desired_props.keys():
+                key, value = (s.strip() for s in line.split('=', 1))
+                if key in list(desired_props.keys()):
                     self._info[desired_props[key]] = value
 
         if self._info.get('device_id', '').lower() == 'flame':
@@ -292,7 +292,7 @@ def get_version(binary=None, sources=None, dm_type=None, host=None,
 
     for (key, value) in sorted(version._info.items()):
         if value:
-            version._logger.info('%s: %s' % (key, value))
+            version._logger.info('{}: {}'.format(key, value))
 
     return version._info
 
diff --git a/testing/mozbase/mozversion/tests/test_b2g.py b/testing/mozbase/mozversion/tests/test_b2g.py
index 09e0eb09e9..9a2a151114 100644
--- a/testing/mozbase/mozversion/tests/test_b2g.py
+++ b/testing/mozbase/mozversion/tests/test_b2g.py
@@ -40,7 +40,7 @@ class SourcesTest(unittest.TestCase):
         app_zip = zipfile.ZipFile(zip_path, 'w')
         if revision or date:
             app_zip.writestr('resources/gaia_commit.txt',
-                             '%s\n%s' % (revision, date))
+                             '{}\n{}'.format(revision, date))
         app_zip.close()
 
     def test_gaia_commit(self):
diff --git a/testing/mozbase/setup_development.py b/testing/mozbase/setup_development.py
index c048d504f1..93d3aa26af 100755
--- a/testing/mozbase/setup_development.py
+++ b/testing/mozbase/setup_development.py
@@ -13,6 +13,7 @@ If no arguments are given, install all packages.
 See https://wiki.mozilla.org/Auto-tools/Projects/Mozbase
 """
 
+from __future__ import print_function
 import os
 import subprocess
 import sys
@@ -57,7 +58,7 @@ def info(directory):
         call([sys.executable, 'setup.py', 'egg_info'],
              cwd=directory, stdout=PIPE)
     except subprocess.CalledProcessError:
-        print "Error running setup.py in %s" % directory
+        print(("Error running setup.py in %s" % directory))
         raise
 
     # get the .egg-info directory
@@ -71,7 +72,7 @@ def info(directory):
     # read the package information
     pkg_info = os.path.join(egg_info, 'PKG-INFO')
     info_dict = {}
-    for line in file(pkg_info).readlines():
+    for line in open(pkg_info).readlines():
         if not line or line[0].isspace():
             continue  # XXX neglects description
         assert ':' in line
@@ -95,7 +96,7 @@ def get_dependencies(directory):
     requires = os.path.join(directory, egg_info, 'requires.txt')
     dependencies = []
     if os.path.exists(requires):
-        for line in file(requires):
+        for line in open(requires):
             line = line.strip()
             # in requires.txt file, a dependency is a non empty line
             # Also lines like [device] are sections to mark optional
@@ -180,7 +181,7 @@ def main(args=sys.argv[1:]):
     if options.list_dependencies:
         # list the package dependencies
         for package in packages:
-            print '%s: %s' % get_dependencies(os.path.join(here, package))
+            print(('%s: %s' % get_dependencies(os.path.join(here, package))))
         parser.exit()
 
     # gather dependencies
@@ -235,7 +236,7 @@ def main(args=sys.argv[1:]):
     if options.list:
         # list what will be installed
         for package in unrolled:
-            print package
+            print(package)
         parser.exit()
 
     # set up the packages for development
diff --git a/testing/mozbase/test.py b/testing/mozbase/test.py
index 013506fc64..2a329b461b 100755
--- a/testing/mozbase/test.py
+++ b/testing/mozbase/test.py
@@ -9,6 +9,7 @@ run mozbase tests from a manifest,
 by default https://github.com/mozilla/mozbase/blob/master/test-manifest.ini
 """
 
+from __future__ import print_function
 import imp
 import manifestparser
 import mozinfo
@@ -82,7 +83,7 @@ def main(args=sys.argv[1:]):
 
     if options.list_tests:
         # print test paths
-        print '\n'.join(tests)
+        print(('\n'.join(tests)))
         sys.exit(0)
 
     # create unittests
diff --git a/testing/mozbase/versioninfo.py b/testing/mozbase/versioninfo.py
index 82da432a4c..96803a4a0a 100755
--- a/testing/mozbase/versioninfo.py
+++ b/testing/mozbase/versioninfo.py
@@ -9,7 +9,8 @@ List mozbase package dependencies or generate changelogs
 from commit messages.
 """
 
-from collections import Iterable
+from __future__ import print_function
+from collections.abc import Iterable
 from distutils.version import StrictVersion
 import argparse
 import os
@@ -62,7 +63,7 @@ def changelog(args):
                         if StrictVersion(v) == plus_version:
                             return rev
 
-        print("Could not find %s revision for version %s." % (args.module, v or 'latest'))
+        print(("Could not find %s revision for version %s." % (args.module, v or 'latest')))
         sys.exit(1)
 
     from_ref = args.from_ref or get_version_rev()
@@ -83,8 +84,8 @@ def changelog(args):
         lines = [('* %s' if i == 0 else '  %s') % l for i, l in enumerate(lines)]
         return '\n'.join(lines)
 
-    changelog = map(prettify, changelog)
-    print '\n'.join(changelog)
+    changelog = list(map(prettify, changelog))
+    print('\n'.join(changelog))
 
 
 def dependencies(args):
@@ -100,8 +101,8 @@ def dependencies(args):
 
     # print package version information
     for value in info.values():
-        print '%s %s : %s' % (value['Name'], value['Version'],
-                              ', '.join(dependencies[value['Name']]))
+        print('%s %s : %s' % (value['Name'], value['Version'],
+                              ', '.join(dependencies[value['Name']])))
 
 
 def main(args=sys.argv[1:]):
diff --git a/testing/mozharness/examples/action_config_script.py b/testing/mozharness/examples/action_config_script.py
index e1135771e0..fc1cfba41c 100755
--- a/testing/mozharness/examples/action_config_script.py
+++ b/testing/mozharness/examples/action_config_script.py
@@ -4,6 +4,7 @@
 Demonstrate actions and config.
 """
 
+from __future__ import print_function
 import os
 import sys
 import time
@@ -68,11 +69,11 @@ class ActionsConfigExample(BaseScript):
             try:
                 time.sleep(interval)
             except:
-                print
+                print()
                 self.error("Impatient, are we?")
                 sys.exit(1)
             counter += interval
-        print
+        print()
         self.info("Ok, done.")
 
     def _ship1(self):
diff --git a/testing/mozharness/external_tools/clobberer.py b/testing/mozharness/external_tools/clobberer.py
index 300b2bc2f3..761ecfc6dc 100755
--- a/testing/mozharness/external_tools/clobberer.py
+++ b/testing/mozharness/external_tools/clobberer.py
@@ -1,8 +1,9 @@
 #!/usr/bin/python
+from __future__ import print_function
 import sys
 import shutil
-import urllib2
-import urllib
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
+import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
 import os
 import traceback
 import time
@@ -80,7 +81,7 @@ def rmdirRecursive(dir):
         return
 
     # Verify the directory is read/write/execute for the current user
-    os.chmod(dir, 0700)
+    os.chmod(dir, 0o700)
 
     for name in os.listdir(dir):
         full_name = os.path.join(dir, name)
@@ -91,14 +92,14 @@ def rmdirRecursive(dir):
                 # I think this is now redundant, but I don't have an NT
                 # machine to test on, so I'm going to leave it in place
                 # -warner
-                os.chmod(full_name, 0600)
+                os.chmod(full_name, 0o600)
 
         if os.path.isdir(full_name):
             rmdirRecursive(full_name)
         else:
             # Don't try to chmod links
             if not os.path.islink(full_name):
-                os.chmod(full_name, 0700)
+                os.chmod(full_name, 0o700)
             os.remove(full_name)
     os.rmdir(dir)
 
@@ -107,11 +108,11 @@ def do_clobber(dir, dryrun=False, skip=None):
     try:
         for f in os.listdir(dir):
             if skip is not None and f in skip:
-                print "Skipping", f
+                print("Skipping", f)
                 continue
             clobber_path = f + clobber_suffix
             if os.path.isfile(f):
-                print "Removing", f
+                print("Removing", f)
                 if not dryrun:
                     if os.path.exists(clobber_path):
                         os.unlink(clobber_path)
@@ -122,7 +123,7 @@ def do_clobber(dir, dryrun=False, skip=None):
                         shutil.move(f, clobber_path)
                         os.unlink(clobber_path)
             elif os.path.isdir(f):
-                print "Removing %s/" % f
+                print("Removing %s/" % f)
                 if not dryrun:
                     if os.path.exists(clobber_path):
                         rmdirRecursive(clobber_path)
@@ -133,21 +134,21 @@ def do_clobber(dir, dryrun=False, skip=None):
                         shutil.move(f, clobber_path)
                         rmdirRecursive(clobber_path)
     except:
-        print "Couldn't clobber properly, bailing out."
+        print("Couldn't clobber properly, bailing out.")
         sys.exit(1)
 
 
 def getClobberDates(clobberURL, branch, buildername, builddir, slave, master):
     params = dict(branch=branch, buildername=buildername,
                   builddir=builddir, slave=slave, master=master)
-    url = "%s?%s" % (clobberURL, urllib.urlencode(params))
-    print "Checking clobber URL: %s" % url
+    url = "%s?%s" % (clobberURL, six.moves.urllib.parse.urlencode(params))
+    print("Checking clobber URL: %s" % url)
     # The timeout arg was added to urlopen() at Python 2.6
     # Deprecate this test when esr17 reaches EOL
     if sys.version_info[:2] < (2, 6):
-        data = urllib2.urlopen(url).read().strip()
+        data = six.moves.urllib.request.urlopen(url).read().strip()
     else:
-        data = urllib2.urlopen(url, timeout=30).read().strip()
+        data = six.moves.urllib.request.urlopen(url, timeout=30).read().strip()
 
     retval = {}
     try:
@@ -160,8 +161,8 @@ def getClobberDates(clobberURL, branch, buildername, builddir, slave, master):
             retval[builddir] = (builder_time, who)
         return retval
     except ValueError:
-        print "Error parsing response from server"
-        print data
+        print("Error parsing response from server")
+        print(data)
         raise
 
 if __name__ == "__main__":
@@ -196,11 +197,11 @@ if __name__ == "__main__":
     except:
         if options.verbose:
             traceback.print_exc()
-        print "Error contacting server"
+        print("Error contacting server")
         sys.exit(1)
 
     if options.verbose:
-        print "Server gave us", server_clobber_dates
+        print("Server gave us", server_clobber_dates)
 
     now = int(time.time())
 
@@ -214,7 +215,7 @@ if __name__ == "__main__":
     for builddir, (server_clobber_date, who) in server_clobber_dates.items():
         builder_dir = os.path.join(root_dir, builddir)
         if not os.path.isdir(builder_dir):
-            print "%s doesn't exist, skipping" % builder_dir
+            print("%s doesn't exist, skipping" % builder_dir)
             continue
         os.chdir(builder_dir)
 
@@ -223,8 +224,8 @@ if __name__ == "__main__":
         clobber = False
         clobberType = None
 
-        print "%s:Our last clobber date: " % builddir, ts_to_str(our_clobber_date)
-        print "%s:Server clobber date:   " % builddir, ts_to_str(server_clobber_date)
+        print("%s:Our last clobber date: " % builddir, ts_to_str(our_clobber_date))
+        print("%s:Server clobber date:   " % builddir, ts_to_str(server_clobber_date))
 
         # If we don't have a last clobber date, then this is probably a fresh build.
         # We should only do a forced server clobber if we know when our last clobber
@@ -240,9 +241,9 @@ if __name__ == "__main__":
                 # We should also update our clobber date to match the server's
                 our_clobber_date = server_clobber_date
                 if who:
-                    print "%s:Server is forcing a clobber, initiated by %s" % (builddir, who)
+                    print("%s:Server is forcing a clobber, initiated by %s" % (builddir, who))
                 else:
-                    print "%s:Server is forcing a clobber" % builddir
+                    print("%s:Server is forcing a clobber" % builddir)
 
         if not clobber:
             # Disable periodic clobbers for builders that aren't my_builddir
@@ -264,11 +265,11 @@ if __name__ == "__main__":
                 clobberType = "periodic"
                 # Update our clobber date to now
                 our_clobber_date = now
-                print "%s:More than %s seconds have passed since our last clobber" % (builddir, periodicClobberTime)
+                print("%s:More than %s seconds have passed since our last clobber" % (builddir, periodicClobberTime))
 
         if clobber:
             # Finally, perform a clobber if we're supposed to
-            print "%s:Clobbering..." % builddir
+            print("%s:Clobbering..." % builddir)
             do_clobber(builder_dir, options.dryrun, options.skip)
             write_file(our_clobber_date, "last-clobber")
 
@@ -276,4 +277,4 @@ if __name__ == "__main__":
         # Note in the case of purged clobber, we output the clobber type even though no
         # clobber was performed this time.
         if clobberType and builddir == my_builddir:
-            print "TinderboxPrint: %s clobber" % clobberType
+            print("TinderboxPrint: %s clobber" % clobberType)
diff --git a/testing/mozharness/external_tools/count_and_reboot.py b/testing/mozharness/external_tools/count_and_reboot.py
index 9e8ae35a65..643ddc2c40 100755
--- a/testing/mozharness/external_tools/count_and_reboot.py
+++ b/testing/mozharness/external_tools/count_and_reboot.py
@@ -6,6 +6,7 @@
 Increments the value in countfile, and reboots the machine once the count
 reaches or exceeds maxcount."""
 
+from __future__ import print_function
 import os, sys, time
 
 if sys.platform in ('darwin', 'linux2'):
@@ -55,8 +56,8 @@ if __name__ == '__main__':
     if increment_count(options.countfile) >= options.maxcount:
         if options.zero:
             open(options.countfile, "w").write("0\n")
-        print "************************************************************************************************"
-        print "*********** END OF RUN - NOW DOING SCHEDULED REBOOT; FOLLOWING ERROR MESSAGE EXPECTED **********"
-        print "************************************************************************************************"
+        print("************************************************************************************************")
+        print("*********** END OF RUN - NOW DOING SCHEDULED REBOOT; FOLLOWING ERROR MESSAGE EXPECTED **********")
+        print("************************************************************************************************")
         sys.stdout.flush()
         reboot()
diff --git a/testing/mozharness/external_tools/detect_repo.py b/testing/mozharness/external_tools/detect_repo.py
index 67466a03e0..fbc8024653 100644
--- a/testing/mozharness/external_tools/detect_repo.py
+++ b/testing/mozharness/external_tools/detect_repo.py
@@ -2,20 +2,20 @@
 # Stolen from taskcluster-vcs
 # https://github.com/taskcluster/taskcluster-vcs/blob/master/src/vcs/detect_remote.js
 
-from urllib2 import Request, urlopen
-from urlparse import urlsplit, urlunsplit
+from urllib.request import Request, urlopen
+from urllib.parse import urlsplit, urlunsplit
 from os.path import exists, join
 
 def first(seq):
-    return next(iter(filter(lambda x: x, seq)), '')
+    return next(iter([x for x in seq if x]), '')
 
 def all_first(*sequences):
-    return map(lambda x: first(x), sequences)
+    return [first(x) for x in sequences]
 
 # http://codereview.stackexchange.com/questions/13027/joining-url-path-components-intelligently
 # I wonder why this is not a builtin feature in Python
 def urljoin(*parts):
-    schemes, netlocs, paths, queries, fragments = zip(*(urlsplit(part) for part in parts))
+    schemes, netlocs, paths, queries, fragments = list(zip(*(urlsplit(part) for part in parts)))
     scheme, netloc, query, fragment = all_first(schemes, netlocs, queries, fragments)
     path = '/'.join(p.strip('/') for p in paths if p)
     return urlunsplit((scheme, netloc, path, query, fragment))
diff --git a/testing/mozharness/external_tools/download_file.py b/testing/mozharness/external_tools/download_file.py
index 91b0a46685..bd149fd185 100755
--- a/testing/mozharness/external_tools/download_file.py
+++ b/testing/mozharness/external_tools/download_file.py
@@ -9,17 +9,18 @@
 We lose some mozharness functionality by splitting this out, but we gain output_timeout.
 """
 
+from __future__ import print_function
 import os
 import socket
 import sys
-import urllib2
-import urlparse
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
+import six.moves.urllib.parse
 
 
 def download_file(url, file_name):
     try:
         f_length = None
-        f = urllib2.urlopen(url, timeout=30)
+        f = six.moves.urllib.request.urlopen(url, timeout=30)
         if f.info().get('content-length') is not None:
             f_length = int(f.info()['content-length'])
             got_length = 0
@@ -28,42 +29,42 @@ def download_file(url, file_name):
             block = f.read(1024 ** 2)
             if not block:
                 if f_length is not None and got_length != f_length:
-                    raise urllib2.URLError("Download incomplete; content-length was %d, but only received %d" % (f_length, got_length))
+                    raise six.moves.urllib.error.URLError("Download incomplete; content-length was %d, but only received %d" % (f_length, got_length))
                 break
             local_file.write(block)
             if f_length is not None:
                 got_length += len(block)
         local_file.close()
-        print "%s downloaded to %s" % (url, file_name)
-    except urllib2.HTTPError, e:
-        print "Warning: Server returned status %s %s for %s" % (str(e.code), str(e), url)
+        print("%s downloaded to %s" % (url, file_name))
+    except six.moves.urllib.error.HTTPError as e:
+        print("Warning: Server returned status %s %s for %s" % (str(e.code), str(e), url))
         raise
-    except urllib2.URLError, e:
-        print "URL Error: %s" % url
-        remote_host = urlparse.urlsplit(url)[1]
+    except six.moves.urllib.error.URLError as e:
+        print("URL Error: %s" % url)
+        remote_host = six.moves.urllib.parse.urlsplit(url)[1]
         if remote_host:
             os.system("nslookup %s" % remote_host)
         raise
-    except socket.timeout, e:
-        print "Timed out accessing %s: %s" % (url, str(e))
+    except socket.timeout as e:
+        print("Timed out accessing %s: %s" % (url, str(e)))
         raise
-    except socket.error, e:
-        print "Socket error when accessing %s: %s" % (url, str(e))
+    except socket.error as e:
+        print("Socket error when accessing %s: %s" % (url, str(e)))
         raise
 
 if __name__ == '__main__':
     if len(sys.argv) != 3:
         if len(sys.argv) != 2:
-            print "Usage: download_file.py URL [FILENAME]"
+            print("Usage: download_file.py URL [FILENAME]")
             sys.exit(-1)
-        parts = urlparse.urlparse(sys.argv[1])
+        parts = six.moves.urllib.parse.urlparse(sys.argv[1])
         file_name = parts[2].split('/')[-1]
     else:
         file_name = sys.argv[2]
     if os.path.exists(file_name):
-        print "%s exists; removing" % file_name
+        print("%s exists; removing" % file_name)
         os.remove(file_name)
     if os.path.exists(file_name):
-        print "%s still exists; exiting"
+        print("%s still exists; exiting")
         sys.exit(-1)
     download_file(sys.argv[1], file_name)
diff --git a/testing/mozharness/external_tools/extract_and_run_command.py b/testing/mozharness/external_tools/extract_and_run_command.py
index ab48ee1dff..828f95cca7 100644
--- a/testing/mozharness/external_tools/extract_and_run_command.py
+++ b/testing/mozharness/external_tools/extract_and_run_command.py
@@ -20,7 +20,7 @@ import logging
 import os
 from os import path
 import sys
-from Queue import Queue
+from queue import Queue
 import shutil
 import subprocess
 import tempfile
@@ -75,7 +75,7 @@ def find_files(d):
             yield path.abspath(path.join(root, f))
 
 
-def rchmod(d, mode=0755):
+def rchmod(d, mode=0o755):
     """chmods everything in `d' to `mode', including `d' itself"""
     os.chmod(d, mode)
     for root, dirs, files in os.walk(d):
@@ -90,7 +90,7 @@ def maybe_extract(filename):
        directory and chmods it. The consumer is responsible for removing
        the extracted files, if desired."""
     ext = path.splitext(filename)[1]
-    if ext not in EXTRACTORS.keys():
+    if ext not in list(EXTRACTORS.keys()):
         return None
     # Append the full filepath to the tempdir
     tempdir_root = tempfile.mkdtemp()
